package Logic::SAMFS;
#<copyright>
# ----------------------------------------------------------
# Sun Proprietary/Confidential Code
# Copyright 2001, Sun Microsystems, Inc. All rights reserved.
# ----------------------------------------------------------
#</copyright>
#  $Name:  $ 
#  $Id: SAMFS.pm,v 1.6 2004/05/25 01:45:13 bkeslin Exp $


use Util;
use strict;
use Agent::SAMFS;
use Logic;

sub addToConfig {
   my($class, $samfs_config) = @_;
   my ($err, $ipno, $active, $x, $pingout);
   $active = "Y";
   my @nodes;

   while (1) {
     if (!$samfs_config->{ip}) {
        $err = Error->error(103);
        last;
     } else {

        my($renv, $devs, $hosts,$notifs) = PDM::ConfigFile->read();

	($err, $pingout) = Util->run_command("/usr/sbin/ping $samfs_config->{ip}");
	if ($pingout->[0] !~ /alive$/ ) {
	   $err = Error->warning("cannot_discover",  "Can not ping $samfs_config->{ip}");
           last;
	}

        my $local_ip = Util->name2ip();
        my $samfs_ip  = Util->name2ip($samfs_config->{ip});

	if ($local_ip eq $samfs_ip) {
            my $package_v = System->getPackageInfo("", "SUNWsamfsr", "VERSION");
            if ($package_v !~ /^4.1/) {
              $err = Error->warning("cannot_discover",  "Current version ($package_v) is not 4.1");
              last;
            }
        }

        my $key = "samfs_$samfs_config->{ip}";
        if (!$key) {
           $err = Error->warning("cannot_discover",  "$samfs_config->{ip}");
           last;
        }
        my %THERE;
        foreach $x (@$devs) {
          if (index("samfs", $x->{type}) >= 0) {
             $THERE{$x->{key}} = 1;
          }
        }
        if (!$THERE{$key}) {
           $x = $#$devs + 1;
           PDM::ConfigFile->addDevice($devs, {
           type     => "samfs",
           class    => "application.samfs",
           key      => $key,
           name     => $samfs_config->{name} || $samfs_config->{ip},
           active   => $active,
           ip       => $samfs_config->{ip},
           ipno     => Util->name2ip($samfs_config->{ip}),
           host     => $samfs_config->{host},
           userLabel => "SAM-QFS",
           });
           Logic->clearSlave($samfs_config->{host}, $hosts);
           push(@nodes, $devs->[$x]);

           if (!PDM::ConfigFile->write( $renv, $devs, $hosts,$notifs)) {
             $err = Error->error(101);
           }
        }
     }
     last;
    }
out:
    return ($err, \@nodes);
}

1;

